2020 hdu 多校三 1007 Tokitsukaze and Rescue

这题非常暴力,每次枚举最短路上一条边删掉,然后再跑最短路,一直到删完k条边,复杂度极限可以到n^10,不过由于边权值随机,最短路边数不会很大,spfa又比较快,所以就暴力出奇迹了

Problem Description

Princess CJB has lived almost her entire life in the isolated town of Ertona, where CJB uses her unique ability to recognize where crystals of materials are buried. By way of a fateful encounter, CJB learns of the Alchemy Exam and decides to take her first step into the outside world, setting off on a grand journey to become a certified alchemist and discover the mysteries that life has to offer!

In order to take part in the Alchemy Exam, CJB goes to the Reisenberg town without any partners. But the kingdom Adalet is unbelievably enormous so that there are many hidden risks. Claris, a powerful evil magician, wants to monopolize CJB for the extraordinary beauty of her. Due to the power limitation of CJB, she can't escape from Claris without any assistance. The alchemist Tokitsukaze has heard this savage act and wants to rescue the princess CJB.

There are n cities numbered from 1 to n in the kingdom Adalet. Because of the excellent transportation, there is exactly a two-way road between any two cites. Tokitsukaze lives in city 1. The Magician Claris lives in city n. Since the exam will be held soon, Tokitsukaze wants to rescue CJB as fast as possible, so she will choose the shortest path to reach city n.

Claris has also heard this news and is afraid of being punished, so he decides to slow Tokitsukaze down by making an explosion on k roads he chose and causing these roads to lose their capability of two-way transportation, since it can pave the way for having enough time to prepare his powerful magic against Tokitsukaze.

Tokitsukaze knows some roads will be destroyed and can immediately recognize where they are, but she has no approach to prevent this explosion, so she chooses just to move along the shortest path after Claris completes his explosion.

Now Claris wants to know, after finishing his explosion, what the longest possible length is of the shortest path from city 1 to city n.

Input

There are several test cases.

The first line contains an integer T (1≤T≤100), denoting the number of test cases. Then follow all the test cases.

For each test case, the first line contains two integers n and k (3≤n≤50,1≤k≤min(n−2,5)), denoting the number of cities and the number of roads being exploded, respectively.

The next n(n−1)2 lines describe all the roads, where each line contains three integers u, v and w (1≤u,v≤n,u≠v,1≤w≤104), representing a two-way road of length w between city u and city v. It is guaranteed that for every two cities, there exists exactly one road whose length is randomly distributed between 1 and 104.

Output

For each case, output in one line an integer, denoting the longest possible length of the shortest path after the explosion.

Sample Input

 

3 5 1 1 2 2990 1 3 2414 1 4 4018 1 5 6216 2 3 9140 2 4 4169 2 5 550 3 4 6618 3 5 3206 4 5 105 5 2 1 2 2990 1 3 2414 1 4 4018 1 5 6216 2 3 9140 2 4 4169 2 5 550 3 4 6618 3 5 3206 4 5 105 5 3 1 2 2990 1 3 2414 1 4 4018 1 5 6216 2 3 9140 2 4 4169 2 5 550 3 4 6618 3 5 3206 4 5 105

Sample Output

 

4123 5620 6216

Source

2020 Multi-University Training Contest 3

Recommend

liuyiding   |   We have carefully selected several similar problems for you:  6801 6800 6799 6798 6797 

#include<bits/stdc++.h>
using namespace std;
#define ll long long
queue<int>q;int n,k;
#define maxn 55
int dis[maxn],mp[maxn][maxn],pre[maxn],vis[maxn],ans=0;
void spfa()
{
    memset(vis,0,sizeof(vis));
    memset(dis,0x3f,sizeof(dis));
    while(!q.empty()) q.pop();
    q.push(1);
    dis[1]=0;
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        vis[u]=0;
        //printf("u=%d\n",u);
        for(int v=1;v<=n;v++)
        {
            if(v==u||mp[u][v]==1e9) continue;
            if(dis[u]+mp[u][v]<dis[v])
            {
                //printf(" v=%d\n",v);
                dis[v]=dis[u]+mp[u][v];
                pre[v]=u;
                if(vis[v]==0)
                {
                    vis[v]=1;q.push(v);
                }

            }
        }
    }
}
void dfs(int x)
{
    spfa();
    ans=max(dis[n],ans);
    if(x==k) return;
    int u=n;
    //printf("---x=%d\n",x);
    int fa[55];
    for(int i=1;i<=n;i++) fa[i]=pre[i];
    while(u!=1)
    {
        //printf("u1=%d\n",u);
        //printf("1111111111111111\n");
        int w=mp[u][fa[u]],v=fa[u];
        mp[u][v]=mp[v][u]=1e9;
        dfs(x+1);
        mp[u][v]=mp[v][u]=w;
        u=fa[u];
    }
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        ans=0;
        scanf("%d %d",&n,&k);
        for(ll i=1;i<=n*(n-1)/2;i++)
        {
            int u,v,w;
            scanf("%d %d %d",&u,&v,&w);
            mp[u][v]=mp[v][u]=w;
        }
        dfs(0);
        printf("%d\n",ans);
    }
}

猜你喜欢

转载自blog.csdn.net/qq_43497140/article/details/107671602